#include <stdio.h>
#include <stdlib.h> //malloc
#include <string.h>

void Vstup (char ***Retez, int *Pocet)
{
	int X=0,Y=0, MaxX=10, MaxY=10;
	*Retez=(char**)malloc(MaxY*sizeof(char*));
	(*Retez)[0]=(char*)malloc(MaxX*sizeof(char));
	while (1)
	{
		scanf("%c",&((*Retez)[Y][X++]));
		if (feof(stdin))
		{
			*Pocet=Y;
			return;
		}
		if (X>=MaxX)
		{
			MaxX*=2;
			(*Retez)[Y]=realloc((*Retez)[Y],MaxX*sizeof (char));
		}
		if ((*Retez)[Y][X-1]=='\n')
		{
			(*Retez)[Y][X-1]='\0';
			MaxX=10;
			X=0;
			Y++;
			if (Y>=MaxY)
			{
				MaxY*=2;
				*Retez=realloc(*Retez, MaxY*sizeof (char*));
			}
			(*Retez)[Y]=(char*)malloc(MaxX*sizeof(char));
		}
	}
	return;
}

void Vystup(char **Retez,int PocetPrvku) 		// void - nemá návratovou hodnotu
{
	int I;
	for (I=0; I<PocetPrvku;I++)
	{
		printf("%s\n",Retez[I]);
	}
}

void QuickSort(char ***Retez, int N)
{
	char **Pole1, **Pole2, **Pole3, *Pivot;
	int I, J=0, K=0, L=0, Porovnani;
	if (N<2) return;
	Pole1=(char**) malloc(N*sizeof (char*)); //časově výhodné, ale zabírá více paměti
	Pole2=(char**) malloc(N*sizeof (char*));
	Pole3=(char**) malloc(N*sizeof (char*));
	Pivot=(char*)malloc((strlen((*Retez)[0])+1)*sizeof(char));
	strcpy(Pivot,(*Retez)[0]);
	for(I=0;I<N;I++)
	{
		Porovnani=strcmp(Pivot,(*Retez)[I]);
		if (Porovnani>0)
		{
			Pole1[J]=(char*)malloc((strlen((*Retez)[I])+1)*sizeof(char));
			strcpy(Pole1[J++],(*Retez)[I]);
		}
		else if (Porovnani==0)
		{
			Pole2[K]=(char*)malloc((strlen((*Retez)[I])+1)*sizeof(char));
			strcpy(Pole2[K++],(*Retez)[I]);
		}
		else
		{
			Pole3[L]=(char*)malloc((strlen((*Retez)[I])+1)*sizeof(char));
			strcpy(Pole3[L++],(*Retez)[I]);
		}

	}
	QuickSort(&Pole1, J);
	QuickSort(&Pole3, L);
	for(I=0;I<J;I++)
	{
		free((*Retez)[I]);
		(*Retez)[I]=(char*)malloc((strlen(Pole1[I])+1)*sizeof(char));
		strcpy((*Retez)[I],Pole1[I]);
		free(Pole1[I]);
	}
	for(I=0;I<K;I++)
	{
		free((*Retez)[I+J]);
		(*Retez)[I+J]=(char*)malloc((strlen(Pole2[I])+1)*sizeof(char));
		strcpy((*Retez)[I+J],Pole2[I]);
		free(Pole2[I]);
	}
	for(I=0;I<L;I++)
	{
		free((*Retez)[I+J+K]);
		(*Retez)[I+J+K]=(char*)malloc((strlen(Pole3[I])+1)*sizeof(char));
		strcpy((*Retez)[I+J+K],Pole3[I]);
		free(Pole3[I]);
	}
	free(Pole1);
	free(Pole2);
	free(Pole3);
	free(Pivot);
}

int main (void)
{
	char **Znaky;
	int Pocet,I;
	Vstup(&Znaky,&Pocet);
	QuickSort(&Znaky,Pocet);
	Vystup(Znaky,Pocet);
	for(I=0;I<Pocet;I++) free(Znaky[I]);
	free(Znaky);
	return 0;
}

